'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.help = help;
exports.setup = setup;

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _nodemiral = require('nodemiral');

var _nodemiral2 = _interopRequireDefault(_nodemiral);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = (0, _debug2.default)('mup:module:docker');

function help() {
  log('exec => mup docker help');
}

function setup(api) {
  log('exec => mup docker setup');
  var list = _nodemiral2.default.taskList('Setup Docker');

  list.executeScript('setup docker', {
    script: (0, _utils.resolvePath)(__dirname, 'assets/docker-setup.sh')
  });

  var sessions = api.getSessions(['meteor', 'mongo', 'proxy']);
  var rsessions = sessions.reduce(function (prev, curr) {
    if (prev.map(function (session) {
      return session._host;
    }).indexOf(curr._host) === -1) {
      prev.push(curr);
    }
    return prev;
  }, []);
  return (0, _utils.runTaskList)(list, rsessions);
}