'use strict';

var _utils = require('../../utils');

var _mocha = require('mocha');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _shelljs = require('shelljs');

var _shelljs2 = _interopRequireDefault(_shelljs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/* eslint-disable max-len */


_shelljs2.default.config.silent = false;
var servers = require('../../../../tests/servers');

(0, _mocha.describe)('module - meteor', function () {
  this.timeout(600000);

  // async function cleanup(server) {
  //   await runSSHCommand(
  //     server,
  //     'sudo apt-get -y purge docker-engine && sudo apt-get -y autoremove --purge docker-engine && sudo rm -rf /var/lib/docker && sudo rm -rf /opt/myapp || :'
  //   );
  // }

  (0, _mocha.describe)('help', function () {
    (0, _mocha.it)('TODO write tests');
  });

  (0, _mocha.describe)('setup', function () {
    var _this = this;

    (0, _mocha.it)('should setup enviranment on "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
      var serverInfo, out, num, sshOut;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              serverInfo = servers['mymeteor'];
              _context.next = 3;
              return (0, _utils.runSSHCommand)(serverInfo, 'rm -rf /opt/myapp || :');

            case 3:
              _context.next = 5;
              return (0, _utils.runSSHCommand)(serverInfo, 'sudo apt-get -qq update && sudo apt-get -qq install -y tree');

            case 5:

              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              out = _shelljs2.default.exec('mup meteor setup');

              _assert2.default.equal(out.code, 0);

              num = (0, _utils.countOccurences)('Setup Environment: SUCCESS', out.output);

              _assert2.default.equal(num, 1);

              _context.next = 12;
              return (0, _utils.runSSHCommand)(serverInfo, 'tree -pufid /opt');

            case 12:
              sshOut = _context.sent;

              _assert2.default.equal((0, _utils.countOccurences)('/opt/myapp', sshOut.output), 3);
              _assert2.default.equal((0, _utils.countOccurences)('/opt/myapp/config', sshOut.output), 1);
              _assert2.default.equal((0, _utils.countOccurences)('/opt/myapp/tmp', sshOut.output), 1);

            case 16:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    })));
  });

  (0, _mocha.describe)('push', function () {
    var _this2 = this;

    (0, _mocha.it)('should push meteor app bundle to "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
      var serverInfo, out, num, sshOut, sshOut2;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              serverInfo = servers['mymeteor'];


              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              _shelljs2.default.exec('mup meteor setup');

              out = _shelljs2.default.exec('mup meteor push');

              _assert2.default.equal(out.code, 0);

              num = (0, _utils.countOccurences)('Pushing Meteor App Bundle to The Server: SUCCESS', out.output);

              _assert2.default.equal(num, 1);

              _context2.next = 9;
              return (0, _utils.runSSHCommand)(serverInfo, 'ls -al /opt/myapp/tmp/bundle.tar.gz');

            case 9:
              sshOut = _context2.sent;

              _assert2.default.equal(sshOut.code, 0);

              _context2.next = 13;
              return (0, _utils.runSSHCommand)(serverInfo, 'ls -al /opt/myapp/config/start.sh');

            case 13:
              sshOut2 = _context2.sent;

              _assert2.default.equal(sshOut2.code, 0);

            case 15:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2);
    })));
  });

  (0, _mocha.describe)('envconfig', function () {
    var _this3 = this;

    var serverInfo = servers['mymeteor'];
    (0, _mocha.it)('should send the enviranment variables to "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
      var out, num, sshOut;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              _shelljs2.default.exec('mup meteor setup');

              out = _shelljs2.default.exec('mup meteor envconfig');

              _assert2.default.equal(out.code, 0);

              num = (0, _utils.countOccurences)('Sending Environment Variables: SUCCESS', out.output);

              _assert2.default.equal(num, 1);

              _context3.next = 8;
              return (0, _utils.runSSHCommand)(serverInfo, 'ls -al /opt/myapp/config/env.list');

            case 8:
              sshOut = _context3.sent;

              _assert2.default.equal(sshOut.code, 0);

            case 10:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this3);
    })));
  });

  (0, _mocha.describe)('start', function () {
    var _this4 = this;

    var serverInfo = servers['mymeteor'];

    (0, _mocha.it)('should start meteor on "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
      var out, num, sshOut;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              _shelljs2.default.exec('mup setup && mup meteor push && mup meteor envconfig');
              out = _shelljs2.default.exec('mup meteor start');

              _assert2.default.equal(out.code, 0);

              num = (0, _utils.countOccurences)('Start Meteor: SUCCESS', out.output);

              _assert2.default.equal(num, 1);

              _context4.next = 8;
              return (0, _utils.runSSHCommand)(serverInfo, 'curl localhost:80 && exit 0');

            case 8:
              sshOut = _context4.sent;

              _assert2.default.equal(sshOut.code, 0);

            case 10:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this4);
    })));
  });

  (0, _mocha.describe)('deploy', function () {
    var _this5 = this;

    var serverInfo = servers['mymeteor'];
    (0, _mocha.it)('should deploy meteor app on "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee5() {
      var out, num, num2, num3, sshOut;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              _shelljs2.default.exec('mup setup');
              out = _shelljs2.default.exec('mup meteor deploy');

              _assert2.default.equal(out.code, 0);

              num = (0, _utils.countOccurences)('Sending Environment Variables: SUCCESS', out.output);

              _assert2.default.equal(num, 1);

              num2 = (0, _utils.countOccurences)('Start Meteor: SUCCESS', out.output);

              _assert2.default.equal(num2, 1);

              num3 = (0, _utils.countOccurences)('Pushing Meteor App Bundle to The Server: SUCCESS', out.output);

              _assert2.default.equal(num3, 1);

              _context5.next = 12;
              return (0, _utils.runSSHCommand)(serverInfo, 'curl localhost:80 && exit 0');

            case 12:
              sshOut = _context5.sent;

              _assert2.default.equal(sshOut.code, 0);

            case 14:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, _this5);
    })));
  });

  (0, _mocha.describe)('logs', function () {
    var _this6 = this;

    (0, _mocha.it)('should pull the logs from "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee6() {
      var out;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              out = _shelljs2.default.exec('mup meteor logs');

              _assert2.default.equal(out.code, 0);

            case 3:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, _this6);
    })));
  });

  (0, _mocha.describe)('stop', function () {
    var _this7 = this;

    var serverInfo = servers['mymeteor'];
    (0, _mocha.it)('should stop meteor app on "meteor" vm', _asyncToGenerator(regeneratorRuntime.mark(function _callee7() {
      var out, num, sshOut;
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _shelljs2.default.cd(_path2.default.resolve('/tmp', 'tests/project-1'));

              _shelljs2.default.exec('mup setup && mup deploy');
              out = _shelljs2.default.exec('mup meteor stop');

              _assert2.default.equal(out.code, 0);

              num = (0, _utils.countOccurences)('Stop Meteor: SUCCESS', out.output);

              _assert2.default.equal(num, 1);

              _context7.next = 8;
              return (0, _utils.runSSHCommand)(serverInfo, 'curl localhost:80 && exit 0');

            case 8:
              sshOut = _context7.sent;

              _assert2.default.equal(sshOut.code, 7);

            case 10:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, _this7);
    })));
  });
});