'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return new Promise(function (resolve) {
    var params = {
      timeout: 1000,
      package: _package2.default.name,
      auth: {}
    };

    var npm = new _silentNpmRegistryClient2.default();
    var uri = 'https://registry.npmjs.org/npm';
    npm.distTags.fetch(uri, params, function (err, res) {
      if (err) {
        resolve();
        return;
      }

      var npmVersion = res.latest;
      var local = _package2.default.version.split('.').map(function (n) {
        return Number(n);
      });
      var remote = npmVersion.split('.').map(function (n) {
        return Number(n);
      });

      var available = remote[0] > local[0] || remote[0] === local[0] && remote[1] > local[1] || remote[1] === local[1] && remote[2] > local[2];

      if (available) {
        var text = 'update available ' + _package2.default.version + ' => ' + npmVersion;
        text += '\nTo update, run ' + _chalk2.default.green('npm i -g mup');
        console.log((0, _boxen2.default)(text, {
          padding: 1,
          margin: 1,
          align: 'center',
          borderColor: 'yellow'
        }));
      }

      resolve();
    });
  });
};

var _silentNpmRegistryClient = require('silent-npm-registry-client');

var _silentNpmRegistryClient2 = _interopRequireDefault(_silentNpmRegistryClient);

var _boxen = require('boxen');

var _boxen2 = _interopRequireDefault(_boxen);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _package = require('../package.json');

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }