'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = validateServers;

var _utils = require('./utils');

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var schema = _joi2.default.object().keys({
  host: _joi2.default.alternatives(_joi2.default.string().ip({
    version: ['ipv4', 'ipv6']
  }), _joi2.default.string().uri(), _joi2.default.string().trim()).required(),
  username: _joi2.default.string().required(),
  pem: _joi2.default.string().trim(),
  password: _joi2.default.string(),
  opts: _joi2.default.object().keys({
    port: _joi2.default.number()
  })
});

function validateServers(servers) {
  var details = [];
  Object.keys(servers).forEach(function (key) {
    var result = _joi2.default.validate(servers[key], schema, {
      convert: false
    });
    details = (0, _utils.combineErrorDetails)(details, result);
  });
  return details;
}