'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.improveErrors = improveErrors;
exports.addLocation = addLocation;
exports.combineErrorDetails = combineErrorDetails;
exports.serversExist = serversExist;
function improveErrors(error) {
  if (error.type === 'object.allowUnknown') {
    error.message = error.message.replace(' is not allowed', ' is an unknown property');
    error.warning = true;
  } else if (error.type === 'object.without') {
    error.message = error.message.replace(' conflict with forbidden peer ', ' and ') + ' cannot both be defined';
  }

  return error;
}

function addLocation(details, location) {
  return details.map(function (detail) {
    detail.message = 'In "' + location + '", ' + detail.message;
    return detail;
  });
}

function combineErrorDetails(details, results) {
  if (results instanceof Array) {
    return details.concat(results);
  }

  var additionalDetails = results.error ? results.error.details : [];
  return details.concat(additionalDetails);
}

function serversExist(serversConfig, serversUsed) {
  var messages = [];
  var servers = Object.keys(serversConfig);
  var using = Object.keys(serversUsed);
  using.forEach(function (key) {
    if (servers.indexOf(key) === -1) {
      messages.push({
        message: 'Server "' + key + '" doesn\'t exist'
      });
    }
  });

  return messages;
}